---
metadata:
  - name: generator
    content: Diplodoc Platform v5.54.2
  - property: og:type
    content: article
  - property: article:section
    content: Справочник API
  - property: og:title
    content: Создать автодействие
  - property: article:tag
    content: Техническая инструкция
alternate:
  - https://yandex.ru/support/tracker/en/api-ref/queues/create-autoaction.md
  - https://yandex.ru/support/tracker/ru/api-ref/queues/create-autoaction.md
  - href: en/api-ref/queues/create-autoaction.md
    type: text/markdown
    title: Markdown version
  - href: ../../llms.txt
    type: text/markdown
    title: llms.txt
---
> **Documentation Index:** Fetch the complete configuration index at https://yandex.ru/support/tracker/en/llms.txt


# Creating an auto action

Use this request to create an [auto action](https://yandex.ru/support/tracker/en/user/create-autoaction.md).

<div class="request_example method_post yfm-clipboard">
    <p>POST</p>
    <pre><code>https://api.tracker.yandex.net/v3/queues/&lt;queue_ID>/autoactions</code></pre>
    <button class="yfm-clipboard-button"><svg width="16" height="16" viewBox="0 0 24 24" class="yfm-clipboard-icon" data-animation="15">
    <path fill="currentColor" d="M19,21H8V7H19M19,5H8A2,2 0 0,0 6,7V21A2,2 0 0,0 8,23H19A2,2 0 0,0 21,21V7A2,2 0 0,0 19,5M16,1H4A2,2 0 0,0 2,3V17H4V3H16V1Z"></path>
    <path stroke="currentColor" fill="transparent" strokewidth="1.5" d="M9.5 13l3 3l5 -5" visibility="hidden">
        <animate id="visibileAnimation-15" attributeName="visibility" from="hidden" to="visible" dur="0.2s" fill="freeze" begin=""></animate>
        <animate id="hideAnimation-15" attributeName="visibility" from="visible" to="hidden" dur="1s" begin="visibileAnimation-15.end+1" fill="freeze"></animate>
    </path>
</svg>
</button>
</div>

<!-- source: en/api-ref/_assets/style/methods.md -->

<!-- endsource: en/api-ref/_assets/style/methods.md -->

## Query format {#query}

Before making a request, [get permission to access the API](https://yandex.ru/support/tracker/en/api-ref/access.md).

To create an auto action, use an HTTP `POST` request. In the request body, specify the parameters in JSON format.

```json
POST /v3/queues/<queue_ID>/autoactions
Host: api.tracker.yandex.net
Authorization: OAuth <OAuth_token>
X-Org-ID or X-Cloud-Org-ID: <organization_ID>
{
    "name": "<autoaction_name>",
    "filter": [<filtering_conditions>],
    "actions": [<action_parameters>]

}
```

<!-- source: en/api-ref/_includes/headings.md -->
{% cut "Headers" %}

* `Host`: address of the node that provides the API.

* <!-- source: en/api-ref/_includes/authorization.md -->
  `Authorization`: Authorization token about these formats:

    - `OAuth <OAuth_token>`: For authorization using the OAuth 2.0 protocol. [Learn more](https://yandex.ru/support/tracker/en/api-ref/access.md#about_OAuth)

    - `Bearer <IAM_token>`: For authorization using an IAM token, if a Yandex Identity Hub organization is linked to Tracker. [Learn more](https://yandex.ru/support/tracker/en/api-ref/access.md#iam-token)
  <!-- endsource: en/api-ref/_includes/authorization.md -->


* <!-- source: en/api-ref/_includes/org-id.md -->
  `X-Org-ID` or `X-Cloud-Org-ID`: Organization ID.

  - Use the `X-Org-ID` header if a Tracker organization is linked to Yandex 360 for Business.

  - Use the `X-Cloud-Org-ID` header if a Tracker organization is linked to Yandex Identity Hub.

  To get the organization ID, go to **Administration** → [**Organizations**](https://tracker.yandex.com/admin/orgs) and copy the value from the **ID** field. {#find-id}
  <!-- endsource: en/api-ref/_includes/org-id.md -->


{% endcut %}
<!-- endsource: en/api-ref/_includes/headings.md -->

{% cut "Resource" %}

| Parameter | Description | Data type |
----- | ----- | -----
| \<queue_ID\> | Queue ID or key. The queue key is case-sensitive. | String or number |

{% endcut %}

{% cut "Request body parameters" %}

**Required parameters**

{% note info "" %}

In the request body, specify at least one of the parameters: `filter` or `query`.

{% endnote %}

| Parameter | Description | Data type |
----- | ----- | -----
| name | Auto action name | String |
| [filter](#filter) | Array with the issue field filtering conditions that will trigger the auto action | Array of objects |
| query | The query string to filter the issues that will trigger the auto action.<br/>The [query language](../../user/query-filter.md) is used.<br/>For example: `"query": "\"Status\":\"In progress\""` | String |
| [actions](#actions) | Array of actions on issues | Array of objects |

**Additional parameters**

| Parameter | Description | Data type |
----- | ----- | -----
| active | Auto action status. Acceptable values include:<ul><li>`true`: Active</li><li>`false`: Inactive</li></ul> | Boolean |
| enableNotifications | Notification sending statuses. Acceptable values include:<ul><li>`true`: Send.</li><li>`false`: Do not send.</li></ul> | Boolean |
| intervalMillis | Auto action start frequency in milliseconds. The default value is `3600000` (once an hour). | Number |
| calendar | Period for which the auto action is active. It has the `id` parameter specifying the [work schedule](../../manager/schedule.md) ID. | Map item |

{% endcut %}

> Example: Creating an auto action that triggers on issues that meet the filter criteria and changes the status of the issues.
> - An HTTP POST method is used.
> - Create an auto action for the DESIGN queue.
> - Filter criteria: issues in the `In progress` status with **Priority** set to `Critical`.
> - Action performed: the issue status changes to **Need info**.
> - Trigger period: work schedule with the ID of `2`.
> ```json
> POST /v3/queues/DESIGN/autoactions
> Host: api.tracker.yandex.net
> Authorization: OAuth <OAuth_token>
> X-Org-ID or X-Cloud-Org-ID: <organization_ID>
> {
>   "name": "AutoactionName",
>   "filter": {
>           "priority": [
>               "critical"
>            ],
>            "status": [
>                "inProgress"
>             ]
>        },
>    "actions": [
>        {
>           "type": "Transition",
>           "status": {
>               "key": "needInfo"
>               }
>        }
>      ],
>     "calendar": {
>            "id": 2
>        }
> }
> ```

## Response format {#answer}

{% list tabs %}

- Request executed successfully

  <!-- source: en/api-ref/_includes/answer-200.md -->
  If the request is successful, the API returns a response with code `200 OK`.
  <!-- endsource: en/api-ref/_includes/answer-200.md -->

  The request body contains information about the created auto action in JSON format.

  ```json
  {
    "id": 9,
    "self": "https://api.tracker.yandex.net/v3/queues/DESIGN/autoactions/9",
    "queue": {
        "self": "https://api.tracker.yandex.net/v3/queues/DESIGN",
        "id": "26",
        "key": "DESIGN",
        "display": "Design"
    },
    "name": "autoaction_name",
    "version": 1,
    "active": true,
    "created": "2022-01-21T17:10:22.993+0000",
    "updated": "2022-01-21T17:10:22.993+0000",
    "filter": {
        "assignee": [
            "13********"
        ],
        "priority": [
            "critical"
        ]
    },
    "actions": [
        {
            "type": "Transition",
            "id": 1,
            "status": {
                "self": "https://api.tracker.yandex.net/v3/statuses/2",
                "id": "2",
                "key": "needInfo",
                "display": "Need info"
            }
        }
    ],
    "enableNotifications": false,
    "totalIssuesProcessed": 0,
    "intervalMillis": 3600000,
    "calendar": {
            "id": 2
        }
  }
  ```

   {% cut "Response parameters" %}

   | Parameter | Description | Data type |
   ----- | ----- | -----
   | id | Auto action ID | String |
   | self | Link to the auto action | String |
   | [queue](#queue) | Queue to create the auto action. | Can be set as an object, a string (if the [queue key](../../manager/create-queue.md#key) is provided), or a number (if the queue ID is provided). |
   | name | Auto action name | String |
   | version | Auto action version. Each change to the auto action increases the version number. | Number |
   | active | Auto action status. Acceptable values include:<ul><li>`true`: Active</li><li>`false`: Inactive</li></ul> | Boolean |
   | created | Auto action creation date and time in `YYYY-MM-DDThh:mm:ss.sss±hhmm` format | String |
   | updated | Date and time of the auto action's last update in `YYYY-MM-DDThh:mm:ss.sss±hhmm` format | String |
   | [filter](#filter) | Array with the issue field filtering conditions that will trigger the auto action | Array of objects |
   | query | Query string for filtering issues | String |
   | [actions](#actions) | Array of actions on issues | Array of objects |
   | enableNotifications | Notification sending statuses. Acceptable values include:<ul><li>`true`: Send.</li><li>`false`: Do not send.</li></ul> | Boolean |
   | totalIssuesProcessed | Number of issues checked by the auto action when triggered last time | Number |
   | intervalMillis | Auto action start frequency in milliseconds. The default value is `3600000` (once an hour). | Number |
   | calendar | Period for which the auto action is active. It has the `id` parameter specifying the [work schedule](../../manager/schedule.md) ID. | Map item |

   `queue` **object fields** {#queue}

   <!-- source: en/api-ref/_includes/queue.md -->
   | Parameter | Description | Data type |
   ----- | ----- | -----
   | self | Address of the API resource with information about the queue. | String |
   | id | Queue ID. | String |
   | key | Queue key. | String |
   | display | Queue name displayed. | String |
   <!-- endsource: en/api-ref/_includes/queue.md -->

    `filter` **array object fields** {#filter}

   | Parameter | Description | Data type |
   ----- | ----- | -----
   | filter | Array with filtering conditions for issue fields.<br/>Use the request to get the ID of the [global](../issues/get-global-fields.md) or [local](../queues/get-local-fields.md) field. | Array of objects |

   `actions` **array object fields** {#actions}

   | Parameter | Description | Data type |
   ----- | ----- | -----
   | type | Action type. Acceptable values include:<ul><li>`Transition`: Change the issue status.</li><li>`Update`: Change a field value.</li><li>`Event.comment-create`: Add a comment.</li><li>`Webhook`: Send an HTTP request.</li><li>`CalculateFormula`: Calculate a value.</li></ul> | String |
   | id | Action ID | String |
   | [status](#status) | Issue status | String |

   `status` **array object fields** {#status}

   <!-- source: en/api-ref/_includes/status.md -->
   | Parameter | Description | Data type |
   ----- | ----- | -----
   | self | Address of the API resource with information about the status. | String |
   | id | Status ID. | String |
   | key | Status key. | String |
   | display | Status name displayed. | String |
   <!-- endsource: en/api-ref/_includes/status.md -->

   {% endcut %}

- Request failed

    If the request is processed incorrectly, the API returns a message with error details:

    <!-- source: en/api-ref/_includes/answer-error-400.md -->
    400
    :   One or more request parameters have an invalid value.
    <!-- endsource: en/api-ref/_includes/answer-error-400.md -->

    <!-- source: en/api-ref/_includes/answer-error-403.md -->
    403
    :   You are not authorized to perform this action. You can check what rights you have in the Tracker interface. The same rights are required to perform an action via the API and interface.
    <!-- endsource: en/api-ref/_includes/answer-error-403.md -->

    <!-- source: en/api-ref/_includes/answer-error-404.md -->
    404
    :   The requested object was not found. You may have specified an invalid object ID or key.
    <!-- endsource: en/api-ref/_includes/answer-error-404.md -->

    <!-- source: en/api-ref/_includes/answer-error-422.md -->
    422
    :   JSON validation error, the request is rejected.
    <!-- endsource: en/api-ref/_includes/answer-error-422.md -->

    <!-- source: en/api-ref/_includes/answer-error-500.md -->
    500
    :   Internal service error. Try again later.
    <!-- endsource: en/api-ref/_includes/answer-error-500.md -->

    <!-- source: en/api-ref/_includes/answer-error-503.md -->
    503
    :   The API service is temporarily unavailable.
    <!-- endsource: en/api-ref/_includes/answer-error-503.md -->

{% endlist %}
